; [U^XN(C)

Irq_Func:
	.dw	User_Irq_Bank1
	.dw	User_Irq_Bank2
	.dw	User_Irq_Bank1
	.dw	User_Irq_Bank2
	.dw	User_Irq_Bank1
	.dw	User_Irq_Bank2
	.dw	User_Irq_Bank1
	.dw	User_Irq_Bank3

	; 
User:
	; XN[It
	ldx	#$00
	stx	$2001

	; ~[O
;	ldx	#$00	; ~[O
	stx	$a000

	; oN؂ւ
;	ldx	#$00
	lda	#BANK_CHR_BG
	jsr	Util_SetSyncBank
	stx	$8000
	sta	$8001	; set CHR ROM to 0x0000 .. 0x07ff
	inx		; same as ldx #$01
	lda	#BANK_CHR_BG+2
	jsr	Util_SetSyncBank
	stx	$8000
	sta	$8001	; set CHR ROM to 0x0800 .. 0x0fff

	inx		; same as ldx #$02
	lda	#BANK_CHR_BG
	jsr	Util_SetSyncBank
	stx	$8000
	sta	$8001	; set CHR ROM to 0x1000 .. 0x13ff
	inx		; same as ldx #$03
	lda	#BANK_CHR_BG
	jsr	Util_SetSyncBank
	stx	$8000
	sta	$8001	; set CHR ROM to 0x1400 .. 0x17ff
	inx		; same as ldx #$04
	lda	#BANK_CHR_BG
	jsr	Util_SetSyncBank
	stx	$8000
	sta	$8001	; set CHR ROM to 0x1800 .. 0x1bff
	inx		; same as ldx #$05
	lda	#BANK_CHR_BG
	jsr	Util_SetSyncBank
	stx	$8000
	sta	$8001	; set CHR ROM to 0x1c00 .. 0x1fff

	lda	#BANK_PRG_DATA
	jsr	SetPrgBankA
	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB

	; pbg
	ldx	#PS_BG_TEST
	jsr	Pal_SetBGPalette
	ldx	#PS_SP_TEST
	jsr	Pal_SetSPPalette
	lda	#$40
	jsr	Vcmd_SetPalette

	; PRG-RAMݒ
	lda	#$80
	sta	$a001

	; XN[ݒ
;	lda	#$e8
	lda	#$00
	sta	<SCROLL_Y
	lda	#$00
	sta	<SCROLL_X

	; IRQݒ
;	lda	$00
	sta	$c000
	sta	$e000
	sta	<IRQ_LINE

	; jmpߐݒ
	lda	#$6c
	sta	<USR_FNC-1
	sta	IRQ_JMP
	lda	#LOW(Irq_Func)
	sta	IRQ_JMP+1
	lda	#HIGH(Irq_Func)
	sta	IRQ_JMP+2
	lda	#$00
	sta	<USR_FNC
	sta	<USR_FNC+1

	; NMI^XNݒ
	lda	#LOW(User_Nmi)
	sta	NMI_FNC
	lda	#HIGH(User_Nmi)
	sta	NMI_FNC+1

	; TEhݒ
	lda	#LOW(Sound_PlayPCM)
	ldx	#HIGH(Sound_PlayPCM)
	jsr	Fssq_SetDpcmCB

	; XvCg
	jsr	Spr_Init

	jsr	Yeild		; t[܂őҋ@

	inc	<$b1
	; ʏ
	lda	#LOW(Vcmd_Clear)
	ldx	#HIGH(Vcmd_Clear)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@
	inc	<$b1

	; XN[I
	lda	#$8a
	sta	<PPU_REG1
	sta	$2000
	lda	#$1e
	sta	$2001

	jsr	Yeild		; t[܂őҋ@

Test_Init:
	; XvCg
	jsr	Spr_Init

	; ʘg`
	lda	#LOW(Vcmd_Frame)
	ldx	#HIGH(Vcmd_Frame)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; tF[hC
	jsr	FadeIn

Test_Main:
	jsr	TestPrgBank1
	ldx	#$00
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	jsr	TestPrgBank3
	ldx	#$01
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	jsr	TestPrgBank2
	ldx	#$02
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	ldx	#$00
	jsr	TestChrBank1
	ldx	#$03
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	ldx	#$00
	jsr	TestChrBank2
	ldx	#$04
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	ldx	#$01
	jsr	TestChrBank1
	ldx	#$05
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	ldx	#$01
	jsr	TestChrBank2
	ldx	#$06
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	ldx	#$02
	jsr	TestChrBank1
	ldx	#$07
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	ldx	#$02
	jsr	TestChrBank2
	ldx	#$08
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	ldx	#$03
	jsr	TestChrBank1
	ldx	#$09
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	ldx	#$03
	jsr	TestChrBank2
	ldx	#$0a
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	ldx	#$04
	jsr	TestChrBank1
	ldx	#$0b
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	ldx	#$04
	jsr	TestChrBank2
	ldx	#$0c
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	ldx	#$05
	jsr	TestChrBank1
	ldx	#$0d
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	ldx	#$05
	jsr	TestChrBank2
	ldx	#$0e
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	jsr	TestBBackup1
	ldx	#$0f
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	jsr	TestWorkRam1
	ldx	#$10
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

	jsr	TestWorkRam2
	ldx	#$11
	jsr	Draw_Result

	jsr	Yeild		; t[܂őҋ@

Test_Wait:
	lda	#0
	sta	<USR_CNT

	jsr	Yeild_SetEntry	; t[͂

	; XvCg
	jsr	Spr_Init

	dec	<USR_CNT

	jsr	Yeild_Eq	; t[܂őҋ@

	; tF[hAEg
	jsr	FadeOut

Demo_Init:
	lda	#BANK_SNAP1
	sta	<BANK_CUR
	sta	<BANK_START

	; IRQ^XNݒ
	ldx	#LOW(IRQ_JMP)
	ldy	#HIGH(IRQ_JMP)
	stx	IRQ_FNC
	sty	IRQ_FNC+1
	lda	#27
	sta	<IRQ_LINE

	; pbg
	ldx	#PS_BG_TEST+1
	jsr	Pal_SetBGPalette
	ldx	#PS_SP_TEST+1
	jsr	Pal_SetSPPalette

	; BGMt
	lda	#$80+BANK_PRG_BGM
	jsr	Fssq_SetBankBGM
	lda	#LOW(Bgm1_PlayData)
	ldx	#HIGH(Bgm1_PlayData)
	jsr	Fssq_PlayBGM

	jsr	Yeild_SetEntry	; t[͂

	; ꖇG`
	lda	#LOW(Vcmd_Snap)
	ldx	#HIGH(Vcmd_Snap)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; tF[hC
	jsr	FadeIn

Loop:
	jsr	Yeild_SetEntry	; t[͂

	; XvCg
	jsr	Spr_Init

	jsr	Yeild_ReEntry

Foo:
	inc	<$b0
	jmp	IRQ_JMP

TestPrgBank1:
	ldx	#0
	lda	#61
	sta	<FNC_WORK
.1:
	lda	<FNC_WORK
	jsr	SetPrgBankA
	lda	$9fff
	cmp	<FNC_WORK
	beq	.2
	inx
.2:
	dec	<FNC_WORK
	bpl	.1
	txa
	rts

TestPrgBank2:
	ldx	#0
	lda	#61
	sta	<FNC_WORK
.1:
	lda	<FNC_WORK
	jsr	SetPrgBankB
	lda	$bfff
	cmp	<FNC_WORK
	beq	.2
	inx
.2:
	dec	<FNC_WORK
	bpl	.1
	txa
	rts

TestPrgBank3:
	ldx	#0
	lda	#61
	sta	<FNC_WORK
.1:
	lda	<FNC_WORK
	jsr	SetPrgBankA2
	lda	$dfff
	cmp	<FNC_WORK
	beq	.2
	inx
.2:
	dec	<FNC_WORK
	bpl	.1
	lda	#0
	jsr	SetPrgBankA
	txa
	rts

	; x: bank reg index (0-5)
TestChrBank1:
	ldy	#$00
	sty	<FNC_WORK
	sty	$2001
.1:
	lda	<FNC_WORK
	stx	$8000
	sta	$8001

	lda	.pa,x
	sta	$2006
	lda	#$ff
	sta	$2006

	lda	$2007
	lda	$2007
	cmp	<FNC_WORK
	beq	.2
	iny
	bne	.2
	dey
.2:
	lda	<FNC_WORK
	clc
	adc	.step,x
	sta	<FNC_WORK
	bne	.1

	lda	SYN_BANK+1,x
	stx	$8000
	sta	$8001
	lda	#$1e
	sta	$2001

	tya
	rts
.pa:
	.db	$03,$0b,$13,$17,$1b,$1f
.step:
	.db	2,2,1,1,1,1

	; x: bank reg index (0-5)
TestChrBank2:
	ldy	#$00
	sty	<FNC_WORK
	sty	$2001
.1:
	txa
	ora	#$80
	sta	$8000
	lda	<FNC_WORK
	sta	$8001

	lda	.pa,x
	sta	$2006
	lda	#$ff
	sta	$2006

	lda	$2007
	lda	$2007
	cmp	<FNC_WORK
	beq	.2
	iny
	bne	.2
	dey
.2:
	lda	<FNC_WORK
	clc
	adc	.step,x
	sta	<FNC_WORK
	bne	.1

	lda	SYN_BANK+1,x
	stx	$8000
	sta	$8001
	lda	#$1e
	sta	$2001

	tya
	rts
.pa:
	.db	$13,$1b,$03,$07,$0b,$0f
.step:
	.db	2,2,1,1,1,1

TestWorkRam1:
	lda	#$55
	ldy	#$55
	jsr	Util_SetLFSR

	lda	#$60
	sta	<FNC_WORK+1
	ldy	#$00
	sty	<FNC_WORK
.1:
	sty	<FNC_WORK+3
	jsr	Util_UpdateLFSR
	sty	<FNC_WORK+2
	ldy	<FNC_WORK+3
	sta	[FNC_WORK],y
	iny
	lda	<FNC_WORK+2
	sta	[FNC_WORK],y

	iny
	bne	.1
	inc	<FNC_WORK+1
	lda	<FNC_WORK+1
	cmp	#$80
	bne	.1

TestBBackup1:
	lda	#$55
	ldy	#$55
	jsr	Util_SetLFSR

	lda	#$60
	sta	<FNC_WORK+1
	ldy	#$00
	sty	<FNC_WORK
	sty	<FNC_WORK+4
.2:
	sty	<FNC_WORK+3
	jsr	Util_UpdateLFSR
	sty	<FNC_WORK+2
	ldy	<FNC_WORK+3
	cmp	[FNC_WORK],y
	beq	.3
	sec
	rol	<FNC_WORK+4
.3:
	iny
	lda	<FNC_WORK+2
	cmp	[FNC_WORK],y
	beq	.4
	sec
	rol	<FNC_WORK+4
.4:
	iny
	bne	.2
	inc	<FNC_WORK+1
	lda	<FNC_WORK+1
	cmp	#$80
	bne	.2

	lda	<FNC_WORK+4
	rts

TestWorkRam2:
	lda	#$c0
	sta	$a001

	lda	#$60
	sta	<FNC_WORK+1
	ldy	#$00
	sty	<FNC_WORK
.1:
	sta	[FNC_WORK],y
	iny
	bne	.1
	inc	<FNC_WORK+1
	lda	<FNC_WORK+1
	cmp	#$80
	bne	.1

	lda	#$80
	sta	$a001

	jmp	TestBBackup1

	; tF[hC
FadeIn:
	lda	#$07
	sta	<USR_CNT
	jsr	Yeild_SetEntry	; t[͂

	lda	<USR_CNT
	asl	a
	asl	a
	asl	a
	and	#$f0
	jsr	Vcmd_SetPalette

	dec	<USR_CNT
	bne	.1
	jmp	Yeild	; t[܂őҋ@
.1:
	jmp	_ReEntry

	; tF[hAEg
FadeOut:
	lda	#$01
	sta	<USR_CNT
	jsr	Yeild_SetEntry	; t[͂

	lda	<USR_CNT
	asl	a
	asl	a
	asl	a
	and	#$f0
	jsr	Vcmd_SetPalette

	inc	<USR_CNT
	lda	<USR_CNT
	cmp	#$09
	bne	.1
	jmp	Yeild	; t[܂őҋ@
.1:
	jmp	_ReEntry

	; a: 0:OK\ 0ȊO:NG\
Draw_Result:
	cmp	#$01
	txa
	rol	a
	tay
	lda	.lo,y
	ldx	.hi,y
	jmp	Vcmd_SequenceData
.lo:
	.db	LOW(Vcmd_Result1_OK)
	.db	LOW(Vcmd_Result1_NG)
	.db	LOW(Vcmd_Result2_OK)
	.db	LOW(Vcmd_Result2_NG)
	.db	LOW(Vcmd_Result3_OK)
	.db	LOW(Vcmd_Result3_NG)
	.db	LOW(Vcmd_Result4_OK)
	.db	LOW(Vcmd_Result4_NG)
	.db	LOW(Vcmd_Result5_OK)
	.db	LOW(Vcmd_Result5_NG)
	.db	LOW(Vcmd_Result6_OK)
	.db	LOW(Vcmd_Result6_NG)
	.db	LOW(Vcmd_Result7_OK)
	.db	LOW(Vcmd_Result7_NG)
	.db	LOW(Vcmd_Result8_OK)
	.db	LOW(Vcmd_Result8_NG)
	.db	LOW(Vcmd_Result9_OK)
	.db	LOW(Vcmd_Result9_NG)
	.db	LOW(Vcmd_Result10_OK)
	.db	LOW(Vcmd_Result10_NG)
	.db	LOW(Vcmd_Result11_OK)
	.db	LOW(Vcmd_Result11_NG)
	.db	LOW(Vcmd_Result12_OK)
	.db	LOW(Vcmd_Result12_NG)
	.db	LOW(Vcmd_Result13_OK)
	.db	LOW(Vcmd_Result13_NG)
	.db	LOW(Vcmd_Result14_OK)
	.db	LOW(Vcmd_Result14_NG)
	.db	LOW(Vcmd_Result15_OK)
	.db	LOW(Vcmd_Result15_NG)
	.db	LOW(Vcmd_Result16_OK)
	.db	LOW(Vcmd_Result16_NG)
	.db	LOW(Vcmd_Result17_OK)
	.db	LOW(Vcmd_Result17_NG)
	.db	LOW(Vcmd_Result18_OK)
	.db	LOW(Vcmd_Result18_NG)
.hi:
	.db	HIGH(Vcmd_Result1_OK)
	.db	HIGH(Vcmd_Result1_NG)
	.db	HIGH(Vcmd_Result2_OK)
	.db	HIGH(Vcmd_Result2_NG)
	.db	HIGH(Vcmd_Result3_OK)
	.db	HIGH(Vcmd_Result3_NG)
	.db	HIGH(Vcmd_Result4_OK)
	.db	HIGH(Vcmd_Result4_NG)
	.db	HIGH(Vcmd_Result5_OK)
	.db	HIGH(Vcmd_Result5_NG)
	.db	HIGH(Vcmd_Result6_OK)
	.db	HIGH(Vcmd_Result6_NG)
	.db	HIGH(Vcmd_Result7_OK)
	.db	HIGH(Vcmd_Result7_NG)
	.db	HIGH(Vcmd_Result8_OK)
	.db	HIGH(Vcmd_Result8_NG)
	.db	HIGH(Vcmd_Result9_OK)
	.db	HIGH(Vcmd_Result9_NG)
	.db	HIGH(Vcmd_Result10_OK)
	.db	HIGH(Vcmd_Result10_NG)
	.db	HIGH(Vcmd_Result11_OK)
	.db	HIGH(Vcmd_Result11_NG)
	.db	HIGH(Vcmd_Result12_OK)
	.db	HIGH(Vcmd_Result12_NG)
	.db	HIGH(Vcmd_Result13_OK)
	.db	HIGH(Vcmd_Result13_NG)
	.db	HIGH(Vcmd_Result14_OK)
	.db	HIGH(Vcmd_Result14_NG)
	.db	HIGH(Vcmd_Result15_OK)
	.db	HIGH(Vcmd_Result15_NG)
	.db	HIGH(Vcmd_Result16_OK)
	.db	HIGH(Vcmd_Result16_NG)
	.db	HIGH(Vcmd_Result17_OK)
	.db	HIGH(Vcmd_Result17_NG)
	.db	HIGH(Vcmd_Result18_OK)
	.db	HIGH(Vcmd_Result18_NG)


Sound_PlayPCM:
	lda	#$0f
	sta	$4010
	lda	#$40
	sta	$4011
	lda	#((PcmKick-$c000)/64)
	sta	$4012
	lda	#((PcmKick_End-PcmKick-1)/16)
	sta	$4013

	lda	$4015
	and	#$0f
	sta	$4015
	ora	#$10
	sta	$4015
	rts

User_Nmi:
	lda	<PPU_REG1
	and	#$fe
	sta	<PPU_REG1

	lda	SYN_BANK
	beq	.3
	ldx	#6
	asl	a
.1:
	asl	a
	beq	.2
	dex
	cmp	#$80
	bcc	.1
	ldy	SYN_BANK+1,x
	stx	$8000
	sty	$8001
	bcs	.1
.2:
	sta	SYN_BANK
.3:

	lda	$2002	; clear address latch

	rts

				; 26
User_Irq_Bank1:
	lda	#27		; 2
	sta	$c000		; 4
	sta	$e000		; 4
	sta	$e001		; 4
	inc	IRQ_JMP+1	; 6
	inc	IRQ_JMP+1	; 6

	ldy	<BANK_CUR	; 3
	ldx	#$01		; 2
	stx	$8000		; 4
	sty	$8001		; 4
	iny
	iny
	sty	<BANK_CUR
	rts

User_Irq_Bank2:
	lda	#27		; 2
	sta	$c000		; 4
	sta	$e000		; 4
	sta	$e001		; 4
	inc	IRQ_JMP+1	; 6
	inc	IRQ_JMP+1	; 6

	ldy	<BANK_CUR	; 3
	ldx	#$00		; 2
	stx	$8000		; 4
	sty	$8001		; 4
	iny
	iny
	sty	<BANK_CUR
	rts

User_Irq_Bank3:
	lda	#0		; 2
	sta	$c000		; 4
	sta	$e000		; 4
	lda	#LOW(Irq_Func)	; 2
	sta	IRQ_JMP+1	; 4

	ldy	<BANK_START	; 3
	ldx	#$00		; 2
	stx	$8000		; 4
	sty	$8001		; 4
	iny
	iny
	sty	<BANK_CUR
	rts

